<template>
    <div class="app-container" id="">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="80px">
        <el-form-item prop="startTime">
            <el-date-picker
            v-model="queryParams.startTime"
            value-format="yyyy-MM-dd"
            type="date"
            placeholder="开始日期"
            @change="() => queryParams.endTime = ''"
            style="width: 130px"
            />
        </el-form-item>
        <el-form-item>-</el-form-item>
        <el-form-item prop="endTime">
            <el-date-picker
            v-model="queryParams.endTime"
            value-format="yyyy-MM-dd"
            type="date"
            placeholder="结束日期"
            :picker-options="{ disabledDate: (t) => t.getTime() < new Date(queryParams.startTime).getTime() - 86400000}"
            style="width: 130px"
            />
        </el-form-item>
        <el-form-item prop="unitId">
            <treeselect
                v-model="queryParams.unitId"
                :options="unitList" :normalizer="normalizer"
                :show-count="true" style="width: 240px" :disable-branch-nodes="true"
                noChildrenText="没有数据了" noOptionsText="没有数据" noResultsText="没有搜索结果"
                placeholder="请选择退料单位" @select="unitChange"
            />
        </el-form-item>
        <el-form-item prop="proId">
            <treeselect
                v-model="queryParams.proId"
                :options="proList" :normalizer="normalizer"
                :show-count="true" style="width: 240px" :disable-branch-nodes="true"
                noChildrenText="没有数据了" noOptionsText="没有数据" noResultsText="没有搜索结果"
                placeholder="请选择退料工程" @select="proChange"
            />
        </el-form-item>
        <el-form-item prop="keyWord">
          <el-input
            v-model="queryParams.keyWord"
            placeholder="请输入关键字"
            clearable :maxlength="20"
            style="width: 240px"
          />
        </el-form-item>
        <el-form-item prop="impUnitName">
            <el-select v-model="queryParams.impUnitName" placeholder="请选择分公司" clearable style="width: 240px">
                <el-option
                    v-for="item in impUnitNameList"
                    :key="item.impUnitName"
                    :label="item.impUnitName"
                    :value="item.impUnitName"
                ></el-option>
            </el-select>
        </el-form-item>
        <el-form-item>
            <el-button
                type="primary"
                icon="el-icon-search"
                size="mini"
                @click="handleQuery"
                >查询</el-button
            >
            <el-button
                icon="el-icon-refresh"
                size="mini"
                @click="resetQuery"
                >重置</el-button
            >
            <el-button
                type="warning"
                plain
                icon="el-icon-download"
                size="mini"
                @click="handleExport"
                >导出</el-button
            >
        </el-form-item>
      </el-form>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      <el-table v-loading="loading" :data="tableList" border :max-height="650">
          <el-table-column label="序号" align="center" type="index">
                <template scope="scope">
                    <span>{{ (queryParams.pageNum - 1) * queryParams.pageSize + scope.$index+1 }}</span>
                </template>
          </el-table-column>
          <el-table-column label="分公司" align="center" prop="impUnitName" width="150px":show-overflow-tooltip="true"/>
          <el-table-column label="退料单位" align="center" prop="unitName" width="180px"/>
          <el-table-column label="退料工程" align="center" prop="projectName" width="220px"/>
          <el-table-column label="维修单号" align="center" prop="code" width="150px" :show-overflow-tooltip="true"/>
          <el-table-column label="物资名称" align="center" prop="typeModelName" width="120px" :show-overflow-tooltip="true"/>
          <el-table-column label="规格型号" align="center" prop="typeName" width="150px" :show-overflow-tooltip="true"/>
          <el-table-column label="配件名称" align="center" prop="partModelName" width="120px" :show-overflow-tooltip="true"/>
          <el-table-column label="配件规格" align="center" prop="partName" width="150px":show-overflow-tooltip="true"/>
          <el-table-column label="设备编号" align="center" prop="maCode" width="120px" :show-overflow-tooltip="true"/>
          <el-table-column label="单位" align="center" prop="partUnit" :show-overflow-tooltip="true"/>
          <el-table-column label="使用数量" align="center" prop="partNum" :show-overflow-tooltip="true"/>
          <el-table-column label="单价(元)" align="center" prop="partPrice" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                  <span>{{ scope.row.partPrice.toFixed(2) }}</span>
              </template>
          </el-table-column>
          <el-table-column label="金额(元)" align="center" prop="partCost" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                  <span>{{ scope.row.partCost.toFixed(2) }}</span>
              </template>
          </el-table-column>
          <el-table-column label="是否收费" align="center" prop="partType" :show-overflow-tooltip="true">
              <template slot-scope="scope">
                <el-tag v-if="scope.row.partType == 1" effect="plain">收费</el-tag>
                <el-tag type="warning" v-if="scope.row.partType == 0" effect="plain">不收费</el-tag>
                <el-tag v-if="scope.row.partType == null" effect="plain">不收费</el-tag>
              </template>
          </el-table-column>
          <el-table-column label="使用班组" align="center" prop="createBy" width="120px" :show-overflow-tooltip="true"/>
      </el-table>
      <pagination
          v-show="total > 0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          :page-sizes="[10, 20, 50, 100]"
          @pagination="getList"
      />


    </div>
</template>

<script>
import {
  getPartUsingListApi,
} from '@/api/stquery/stquery';
import {
    getProjectList,
    getUnitList,
    getImpUnitNameListApi,
} from '@/api/back/index.js'
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
export default {
    name: 'PartUsing',
    dicts: [],
    components: { Treeselect },
    data() {
        return {
            // 遮罩层
            loading: false,
            // 选中数组
            ids: [],
            // 弹出层标题
            title: '查看',
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            selectTreeProps: {
                children: 'children',
                label: 'name',
                // multiple: false,
                value: 'id',
                // multiple: true,
            },
            unitId: null,
            projectId: null,
            unitList: [],
            proList: [],
            // 总条数
            total: 0,
            // 主表格数据
            tableList: [],
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                time: null,
                unitId: null,
                proId: null,
                keyWord: null,
                typeName: null, //物资名称
                statusName: null, //状态
                startTime: null,
                endTime: null,
                impUnitName: null, //分公司
            },
            impUnitNameList: [],
        }
    },
    computed: {
        groupPrintData() {
            const result = [];
            for (let i = 0; i < this.printTableData.length; i += 2) {
                const group = this.printTableData.slice(i, i + 2);
                // 若分组不足 2 个元素，补充空对象
                while (group.length < 2) {
                    group.push({ partName: '', status: '' });
                }
                result.push(group);
            }
            return result;
        },
    },
    created() {
        const end = new Date()
        let start = new Date()
        start.setMonth(start.getMonth() - 1)
        this.queryParams.startTime = this.format(start)
        this.queryParams.endTime = this.format(end)
        this.initSelectData()
        this.getImpUnitNameList()
        this.getList()
    },
    methods: {
      format(date) {
        const y = date.getFullYear()
        const m = String(date.getMonth() + 1).padStart(2, '0')
        const day = String(date.getDate()).padStart(2, '0')
        return `${y}-${m}-${day}`
      },

        // 定义格式化日期的方法
      formatDate(dateStr) {
        if (!dateStr) return '';
        const date = new Date(dateStr);
        const year = date.getFullYear();
        const month = String(date.getMonth() + 1).padStart(2, '0');
        const day = String(date.getDate()).padStart(2, '0');
        return `${year}-${month}-${day}`;
      },

      initSelectData() {
          this.GetUnitData()
          this.GetProData()
      },
      /** 转换菜单数据结构 */
      normalizer(node) {
            if (node.children && !node.children.length) {
                delete node.children;
            }
            return {
                id: node.id,
                label: node.name,
                children: node.children,
            };
        },

      // 分公司下拉
      async getImpUnitNameList () {
          try {
              const res = await getImpUnitNameListApi()
              this.impUnitNameList = res.data
          } catch (error) {
              console.log('🚀 ~ error:', error)
          }
      }, 

      // 获取 来往单位 列表数据
      async GetUnitData() {
              const params = {
                //   projectId: this.queryParams.proId /*  */,
              }
              const res = await getUnitList(params)
              this.unitList = res.data
      },
      unitChange(val){
        setTimeout(()=>{
            this.GetProData()
        },500)
      },
      // 获取 工程名称 列表数据
      async GetProData() {
              const params = { unitId: this.queryParams.unitId}
              const res = await getProjectList(params)
              this.proList = res.data
              this.queryParams.proId=null
      },
      proChange(val){
        setTimeout(()=>{
            this.GetUnitData()
        },500)
      },

      // 获取列表
      async getList() {
        try {
            this.loading = true
            const params = {
                  unitId: this.queryParams.unitId,
                  proId: this.queryParams.proId,
                  keyWord: this.queryParams.keyWord,
                  typeName: this.queryParams.typeName,
                  statusName: this.queryParams.statusName,
                  impUnitName: this.queryParams.impUnitName,
                  startTime: this.queryParams.startTime,
                  endTime: this.queryParams.endTime,
                  pageSize: this.queryParams.pageSize,
                  pageNum: this.queryParams.pageNum
              }
            const res = await getPartUsingListApi(params)
            this.loading = false
            if(res.rows.length>0){
              this.tableList = res.rows;
            }else{
              this.tableList=[]
            }
            this.total = res.total;
        } catch (error) {
            this.loading = false
        } finally {
            this.loading = false
        }
      },
      /** 搜索按钮操作 */
      handleQuery() {
          this.queryParams.pageNum = 1
          this.getList()
      },
      /** 重置按钮操作 */
      resetQuery() {
        const end = new Date()
        let start = new Date()
        start.setMonth(start.getMonth() - 1)
        this.queryParams.startTime = this.format(start)
        this.queryParams.endTime = this.format(end)
        this.unitId=[]
        this.projectId=[]
        this.resetForm('queryForm')
        this.handleQuery()
      },

      /** 导出按钮操作 */
      handleExport() {
        const formatTime = (date) => {
          const year = date.getFullYear();
          const month = String(date.getMonth() + 1).padStart(2, '0');
          const day = String(date.getDate()).padStart(2, '0');
          const hours = String(date.getHours()).padStart(2, '0');
          const minutes = String(date.getMinutes()).padStart(2, '0');
          const seconds = String(date.getSeconds()).padStart(2, '0');
          return `${year}${month}${day}_${hours}${minutes}${seconds}`;
        };
        const params = {
            unitId: this.queryParams.unitId,
            proId: this.queryParams.proId,
            keyWord: this.queryParams.keyWord,
            typeName: this.queryParams.typeName,
            statusName: this.queryParams.statusName,
            startTime: this.queryParams.startTime,
            endTime: this.queryParams.endTime,
            pageSize: this.queryParams.pageSize,
            pageNum: this.queryParams.pageNum
        }
        const currentTime = formatTime(new Date());
          this.download(
              'material/repair/exportPartUsingList',
              {
                  ...params,
              },
              `配件查询_${currentTime}.xlsx`,
          )
      },

    },
}
</script>
<style lang="scss" scoped>
::v-deep.el-table .fixed-width .el-button--mini {
    width: 60px !important;
    margin-bottom: 10px;
}
.clickText {
  color: #02a7f0;
  cursor: pointer;
}
</style>
